// window.onerror = function (e) { console.error(e); }
window.onload = (function () {
    var isOld = !!(document.querySelector('.old')),
        density = window.devicePixelRatio == 1.5 ? 1.5 : 1;

    try {
        // console.info('start textWrapper noflick');
        if (isOld && document.querySelector('.textWrapper')) {
            document.querySelector('.textWrapper').classList.add('noflick');
        }
        // console.info('textWrapper noflick OK');
    } catch (e) {}

    try {
        // console.info('start last border');
        var innerHeaderNodes = document.querySelectorAll('.innerHeader');
        if (innerHeaderNodes) {
            for (var i = 0, _l = innerHeaderNodes.length; i < _l; i += 1) {
                var prev = innerHeaderNodes[i].previousElementSibling;
                if (prev && prev.classList && prev.classList.contains('defaultCell')) {
                    prev.style.borderBottom = 'none';
                }
            }
        }
        // console.info('last border OK');
    } catch (e) {}

    // remove multiple <br> before and after .newsList lists
    try {
        // console.info('start br lists');
        var listNodes = document.querySelectorAll('.newsList'),
            previousNode, nextNode;
        for (var i = 0, _l = listNodes.length; i < _l; i += 1) {
            previousNode = listNodes[i].previousElementSibling;
            if (previousNode && previousNode.nodeName.toLowerCase() == 'br' &&
                previousNode.previousElementSibling.nodeName.toLowerCase() == 'br'
            ) {
                previousNode.parentNode.removeChild(previousNode);
            }
            nextNode = listNodes[i].nextElementSibling;
            if (nextNode && nextNode.nodeName.toLowerCase() == 'br' &&
                nextNode.nextElementSibling.nodeName.toLowerCase() == 'br'
            ) {
                nextNode.parentNode.removeChild(nextNode);
            }
            listNodes[i].classList.add('noflick');
        }
        // console.info('br lists OK');
    } catch (e) {}

    var globalInterval = setInterval(function () {
        var bodyWidth = document.querySelector('body').offsetWidth;
        // console.info('bodyWidth ' + bodyWidth + '; ' + document.querySelector('body').offsetWidth + ' ' + document.querySelector('body').clientWidth);
        if (!bodyWidth) {
            return;
        } else {
            clearInterval(globalInterval);
        }

        try {
            // console.info('init sliderImages');
            var ratio = 324 / 575;

            if (isOld) {
                document.querySelector('.image-slider-wrapper').style.width = bodyWidth + 'px';
                document.querySelector('.image-slider-wrapper').style.height = (Math.round(ratio * bodyWidth) /*+ 40*/) + 'px';
            }

            document.querySelector('.image-slider-wrapper .navigator').style.top = Math.round(ratio * bodyWidth * (isOld ? 0.9 : 1.0)) + 'px';
            var sliderImages = document.querySelectorAll('.image-slider > div'),
                imageContainer = document.createElement('div'),
                imagesLoaded = 0;

            imageContainer.classList.add('image-container');
            document.querySelector('body').appendChild(imageContainer);

            for (var j = 0, _l = sliderImages.length; j < _l; j += 1) {
                if (sliderImages[j].dataset && sliderImages[j].dataset['image']) {
                    var tempImg = document.createElement('img');
                    tempImg.onload = function () {
                        imagesLoaded += 1;
                        // console.info('something loaded; ' + imagesLoaded + ' ' + sliderImages.length);

                        if (imagesLoaded == sliderImages.length) {
                            // console.info('something loaded OK');

                            if (isOld) {
                                document.querySelector('.image-slider-wrapper').style.height = (Math.round(ratio * bodyWidth) /*+ 40*/) + 'px';
                                document.querySelector('.image-slider-wrapper').style.backgroundColor = 'transparent';
                            }

                            for (var i = 0, _l = sliderImages.length; i < _l; i += 1) {
                                if (sliderImages[i].dataset && sliderImages[i].dataset['image']) {
                                    sliderImages[i].style.width = bodyWidth + 'px';
                                    // if (isOld) {
                                        sliderImages[i].style.paddingTop = Math.round(ratio * bodyWidth) + 'px';
                                    // }
                                    if (isOld) {
                                        sliderImages[i].style.backgroundSize = sliderImages[i].style.webkitBackgroundSize =
                                            bodyWidth + 'px ' + (ratio * bodyWidth) + 'px';
                                    }
                                    sliderImages[i].style.backgroundImage = 'url(' + sliderImages[i].dataset['image'] + ')' +
                                        (isOld ? '' : ', -webkit-linear-gradient(top, #aaa, #aaa)');
                                } else {
                                    console.info('error: no dataset[image]', sliderImages[i].dataset);
                                }
                            }

                            document.querySelector('.image-slider').classList.remove('loading');
                            document.querySelector('body').removeChild(imageContainer);

                            // console.info('init sliderImages OK');

                            sliderLoaded();
                        }
                    }
                    imageContainer.appendChild(tempImg);
                    tempImg.src = sliderImages[j].dataset['image'];
                }
            }
        } catch (e) {}

        try {
            // console.info('start background arrow correct');
            var defaultCells = document.querySelectorAll('.defaultCell');
            if (defaultCells) {
                for (var i = 0, _l = defaultCells.length; i < _l; i += 1) {
                    var delta = (defaultCells[i].classList.contains('socialcell') ? 24 : 12) * density;
                    defaultCells[i].style.backgroundPosition = (bodyWidth - delta) + 'px 50%';
                }
            }
            // console.info('background arrow correct OK');
        } catch (e) {}

        var narrowCellPadding = {left: 0, right: 0};
        if (document.querySelector('.narrowCell')) {
            var computedStyle = window.getComputedStyle(document.querySelector('.narrowCell'), null);
            narrowCellPadding = {
                left: (parseInt(computedStyle.getPropertyValue("padding-left")) || 0),
                right: (parseInt(computedStyle.getPropertyValue("padding-right")) || 0)
            }
        }

        try {
            // console.info('start user_data correct');
            var userDataCells = document.querySelectorAll('.user-data, .vote');
            if (userDataCells) {
                for (var i = 0, _l = userDataCells.length; i < _l; i += 1) {
                    var userDataMargin = userDataCells[i].parentNode.querySelector('.user-data') ?
                        parseInt(window.getComputedStyle(userDataCells[i].parentNode.querySelector('.user-data'), null).getPropertyValue("margin-right")) : 0;
                    var textCell = userDataCells[i].parentNode.querySelector('.name');

                    var maxWidth = parseInt(textCell.style.maxWidth);
                    if (!maxWidth) {
                        maxWidth = bodyWidth - narrowCellPadding.left - narrowCellPadding.right;
                    }

                    textCell.style.maxWidth = (maxWidth - userDataCells[i].getBoundingClientRect().width - userDataMargin - 1) + 'px';
                }
            }
            // console.info('user_data correct OK');

            var narrowCells = document.querySelectorAll('.narrowCell'),
                maxWidth = bodyWidth - narrowCellPadding.left - narrowCellPadding.right;
            // console.info(maxWidth);
            if (narrowCells) {
                for (var i = 0, _l = narrowCells.length; i < _l; i += 1) {
                    if (!narrowCells[i].querySelector('.vote, .user-data')) {
                        narrowCells[i].querySelector('.name').style.maxWidth = maxWidth + 'px';
                    }
                }
            }
        } catch (e) {}

        try {
            // console.info('start year correct');
            var yearNodes = document.querySelectorAll('.en .year'),
                textCell;

            if (yearNodes) {
                for (var i = 0, _l = yearNodes.length; i < _l; i += 1) {
                    textCell = yearNodes[i].parentNode.parentNode;
                    if (textCell.querySelector('.text')) {
                        var maxEnWidth = textCell.style.maxWidth || bodyWidth - narrowCellPadding.left - narrowCellPadding.right;
                        if (maxEnWidth[maxEnWidth.length-1] == '%') {
                            maxEnWidth = parseInt(maxEnWidth) / 100 * bodyWidth;
                            maxEnWidth -= parseInt(window.getComputedStyle(textCell.parentNode, null).getPropertyValue("padding-left"));
                        } else {
                            maxEnWidth = parseInt(maxEnWidth);
                        }

                        textCell.querySelector('.text').style.maxWidth = (maxEnWidth - yearNodes[i].getBoundingClientRect().width - 3 * density) + 'px'; // -paddingForYear

                        // fix incorrect year positioning @ KitKat
                        var delta = yearNodes[i].parentNode.querySelector('.text').getBoundingClientRect().top - yearNodes[i].getBoundingClientRect().top;
                        if (delta) {
                            yearNodes[i].style.position = 'relative';
                            yearNodes[i].style.top = delta + 'px';
                        }
                    }
                }
            }
            // console.info('year correct OK');
        } catch (e) {}

        try {
            // console.info('start winners');
            var winnerNodes = document.querySelectorAll('li a.continue'),
                parentNode;
            for (var i = 0, _l = winnerNodes.length; i < _l; i += 1) {
                parentNode = winnerNodes[i].parentNode;
                parentNode.classList.add('winner');
                parentNode.style.width = bodyWidth + 'px';
                // console.log('winner ' + winnerNodes[i].innerText + ' ' + parentNode.style.width);
            }
            // console.info('winners OK');
        } catch (e) {}

        function sliderLoaded () {
            var container = document.querySelectorAll('.image-slider'),
                images = document.querySelectorAll('.image-slider > div'),
                position = 0,
                currentImageIndex = 0,
                prev = { x: 0, y: 0 },
                imageWidth = bodyWidth; // document.querySelector('body').offsetWidth,
                swipeLength = 30 * density,
                timeout = null;

            if (container.length) {
                container = container[0];
                container.style.width = (images.length * imageWidth * 2) + 'px';
            } else {
                return;
            }

            var disks = document.querySelector('.image-slider-wrapper .navigator');
            for (var i = 0; i < images.length; i += 1) {
                disks.appendChild(document.createElement('span'));
                disks.childNodes[disks.childNodes.length - 1].classList.add('disk');
            }

            var rect = disks.getBoundingClientRect();
            disks.style.left = ((imageWidth - rect.width) / 2) + 'px';
            disks.childNodes[0].classList.add('active');

            if (!isOld) {
                function touchStart (event) {
                    if (event.targetTouches.length) {
                        prev.x = event.targetTouches[0].pageX;
                        prev.y = event.targetTouches[0].pageY;
                    }
                }

                function touchMove (event) {
                    var touch = event.targetTouches ? event.targetTouches[0] : null;
                    if (!(touch && !isNaN(prev.x) && (Math.abs(touch.pageX - prev.x) < 4 || Math.abs(touch.pageX - prev.x) < 2 * Math.abs(touch.pageY - prev.y)))) {
                        event.preventDefault();
                    }

                    if (prev.x == null ||
                        !touch ||
                        event.targetTouches.length > 1 ||
                        Math.abs(touch.pageX - prev.x) < Math.abs(touch.pageY - prev.y) * 2
                    ) {
                        prev = { x: touch.pageX, y: touch.pageY };
                        return;
                    }


                    if (!timeout &&
                        Math.abs(event.targetTouches[0].pageX - prev.x) >= swipeLength
                    ) {
                        var delta = event.targetTouches[0].pageX - prev.x > 0 ? -1 : 1,
                        prevImageIndex = currentImageIndex;
                        currentImageIndex = Math.min(Math.max(currentImageIndex + delta, 0), images.length-1);
                        animate(prevImageIndex);
                    } else if (!container.classList.contains('translating')) {
                        var delta = touch.pageX - prev.x;
                        position = Math.max(Math.min(position + delta, 0), -imageWidth * (images.length-1));
                        container.style.webkitTransform = 'translate3d(' + position + 'px, 0px, 0px)';

                        prev = { x: touch.pageX, y: touch.pageY };
                    }

                }

                function touchEnd (event) {
                    if (timeout) {
                        return;
                    }
                    prev.x = null;
                    var prevImageIndex = currentImageIndex;

                    if (orientationChanging) {
                        orientationChanging = false;
                    } else {
                        for (var i = 0; i < images.length; i += 1) {
                            if ((i > currentImageIndex && position + i * imageWidth - imageWidth < -0.1 * imageWidth) ||
                                (i < currentImageIndex && position + i * imageWidth + imageWidth > 0.1 * imageWidth)
                            ) {
                                currentImageIndex = i;
                                break;
                            }
                        }
                    }
                    animate(prevImageIndex);
                }

                function click () {
                    var prevImageIndex = currentImageIndex;
                    currentImageIndex += 1;
                    if (currentImageIndex < 0) {
                        currentImageIndex = images.length + currentImageIndex;
                    }
                    if (currentImageIndex > images.length - 1) {
                        currentImageIndex = currentImageIndex - images.length;
                    }
                    animate(prevImageIndex);
                }

                function animate(prevImageIndex) {
                    clearTimeout(animationTimeout);
                    container.classList.add('translating');
                    position = -currentImageIndex * imageWidth;
                    container.style.webkitTransform = 'translate3d(' + position + 'px, 0px, 0px)';
                    if (prevImageIndex != currentImageIndex) {
                        document.querySelector('.disk.active').classList.remove('active');
                        document.querySelector('.disk:nth-child(' + (currentImageIndex + 1) + ')').classList.add('active');
                    }
                    timeout = setTimeout(function () {
                        container.classList.remove('translating');
                        timeout = null;
                        animationTimeout = setTimeout(click, 5000);
                    }, 300);
                }

                container.addEventListener("touchstart", touchStart, false);
                container.addEventListener("touchmove", touchMove, false);
                container.addEventListener("touchend", touchEnd, false);
                container.addEventListener("touchcancel", touchEnd, false);
                container.addEventListener("click", click, false);

                var orientationChanging = false;
                document.addEventListener("orientationchange", function () {
                    imageWidth = document.querySelector('body').offsetWidth;
                    disks.style.left = ((imageWidth - disks.getBoundingClientRect().width) / 2) + 'px';
                    orientationChanging = true;

                    var event = document.createEvent('TouchEvent');
                    event.initUIEvent('touchend', true, true);
                    event.view = window;
                    event.altKey = false;
                    event.ctrlKey = false;
                    event.shiftKey = false;
                    event.metaKey = false;
                    container.dispatchEvent(event);
                });

                var animationTimeout = setTimeout(click, 5000);

            } else {
                images[currentImageIndex].style.opacity = 1;
                var interval = null;
                container.addEventListener("touchend", function () {

                    if (interval) {
                       return false;
                    }
                    clearTimeout(animationTimeout);

                    // dont swipe if gallery isnt visible
                    var rect = document.querySelector('.image-slider-wrapper').getBoundingClientRect();
                    if (rect.top < - rect.height * 0.5) {
                        animationTimeout = setTimeout(animateOpacity, 5000);
                        return false;
                    }

                    var progress = 0,
                    currentImage = images[currentImageIndex],
                    nextImageIndex = currentImageIndex + 1;
                    if (nextImageIndex < 0) {
                        nextImageIndex = images.length + nextImageIndex;
                    }
                    if (nextImageIndex > images.length - 1) {
                        nextImageIndex = nextImageIndex - images.length;
                    }
                    var nextImage = images[nextImageIndex];

                    interval = setInterval(function () {
                        if (progress > 1) {
                            clearInterval(interval);
                            interval = null;
                            currentImageIndex = nextImageIndex;
                            animationTimeout = setTimeout(animateOpacity, 5000);
                            document.querySelector('.disk.active').classList.remove('active');
                            document.querySelector('.disk:nth-child(' + (currentImageIndex + 1) + ')').classList.add('active');

                            return;
                        }

                        progress += 1/2; // 0.07 sec

                        nextImage.style.opacity = progress;
                        currentImage.style.opacity = 1 - progress;
                    }, 1000/30);
                }, false);

                function animateOpacity() {
                    var event = document.createEvent('TouchEvent');
                    event.initUIEvent('touchend', true, true);
                    event.view = window;
                    event.altKey = false;
                    event.ctrlKey = false;
                    event.shiftKey = false;
                    event.metaKey = false;
                    container.dispatchEvent(event);
                }
                var animationTimeout = setTimeout(animateOpacity, 5000);
            }
        }
    }, 100);
});
